void fill  ( const unsigned  n, const double f, double * y );
void scale ( const unsigned  n, const double f, double * y );

void add   ( const unsigned  n, const double f, const double * x,
             double * y )
{ for ( unsigned i = 0; i < n; i++ ) y[i] += f * x[i]; }

double
dot ( const unsigned  n, const double * x, const double * y )
{
    double  d = 0.0;
    
    for ( unsigned i = 0; i < n; i++ ) d += x[i] * y[i];
    return d;
}

inline double
norm2 ( const unsigned  n, const double * x )
{ return sqrt( dot( n, x, x ) ); }
