template <typename T_MAT> void
cg ( const T_MAT &  A, vector_t & x, const vector_t & b )
{
    vector_t  r( b ), p, a( x.get_size() );

    mul_vec( -1.0, A, x, r );           // r = b - A x
    p = r;                              // p = r

    for ( size_t it = 0; it < 1000; it++ ) {
        real_t  lambda;

        a.fill( 0.0 );
        mul_vec( 1.0, A, p, a );        // a = A p
        lambda = dot( r, p ) / dot( a, p ); // lambda = <r,p>/<Ap,p>
        x.add(  lambda, p );            // x = x + lambda p;
        r.add( -lambda, a );            // r = r - lambda a
        p.scale( - dot( r, a ) / dot( a, p ) );
        p.add( 1.0, r );                // p = r - (<r,a> / <a,p>) p
        
        if ( r.norm2() < 1e-10 )        // stop crit.: |r|_2 < 1e-10
            break;
}   }
