class vector_t {
private:
    size_t    size;
    real_t *  coeffs;

public:
    vector_t ( const size_t      n = 0 );
    vector_t ( const vector_t &  x );
    ~vector_t ();

    size_t  get_size () const;

    real_t   operator [] ( const size_t  i ) const;
    real_t & operator [] ( const size_t  i );

    void fill  ( const real_t  f );
    void scale ( const real_t  f );
    void add   ( const real_t  f, const vector_t & x );

    vector_t & operator = ( const vector_t & x );
};
