class matrix_t {
private:
    size_t  nrows, ncolumns;
public:
    matrix_t  ( const size_t  n, const size_t  m );
    matrix_t  ( const matrix_t &  M );

    size_t  get_nrows    () const { return nrows };
    size_t  get_ncolumns () const { return ncolumns };

    virtual void   fill    ( const real_t  f ) = 0;
    virtual void   scale   ( const real_t  f ) = 0;
    virtual void   add     ( const real_t  f, const matrix_t & x ) = 0;
    virtual void   mul_vec ( const real_t  alpha, const vector_t & x,
                             vector_t &    y ) const = 0;
    virtual real_t normF   () const = 0;
};
