void
mul_vec ( const real_t   alpha, const sparsematrix_t & S,
          const vector_t x, vector_t & y )
{
    for ( unsigned i = 0; i < S.nrows; i++ )
    {
        real_t    f     = 0.0;
        entry_t * entry = & S.entries[i];

        while ( entry != NULL )
        {
            f     += entry->coeff * x[ entry->column ];
            entry  = entry->next;
        }

        y[ i ] += alpha * f;
    }
}
